import processing.core.*; 
import processing.data.*; 
import processing.opengl.*; 

import ddf.minim.*; 
import ddf.minim.analysis.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class sundown_demo extends PApplet {




Minim minim;
AudioPlayer song;
FFT fft;

int tick = 1;

String DATAPATH = "../";

PImage[] d_t = new PImage[19];
PImage[] s_t = new PImage[5];

float loopStart = 0;
float loopEnd = 0;
float loopCount = 0;

int pause = -1;
int looping = -1;

// REMOVE ME
//int WORK_OFFSET = 230700;

int song_end = 0;

int WORK_OFFSET = 0;
public float t() {
  if (song != null) return (song.position());
  else return 0.0f;
}


PGraphics pat;
PGraphics canvas;

PShader blur;
PShader spiikkitunnel;
PShader blurry;
PShader ilmarieffu;
PShader visyeffu;

PShader krysler;
PShader vis;

PImage bilologo;
PImage kredits;
PImage summon;

int dlc = 64;
float beat = 0;

public boolean sketchFullScreen() {
  return true;
}

class Dirline {
  float xpos, ypos, dx, dy;
  int tick;
  
  Dirline(float x, float y, float ddx, float ddy) {
    xpos = x;
    ypos = y;
    dx = ddx;
    dy = ddy;
    tick = 1;
  }
  
  public void draw(int i) {
   
    float dx = cos(t()*0.001f+i*16)*1;
    float dy = sin(t()*0.001f+i*16)*1;

    
    pat.stroke(dx*255,192*cos(t()+i)*i,tan(t())*255,255*cos(t()*i*0.001f));
    pat.ellipse(xpos, ypos, 50, 50);
    if (tick == 1) xpos+=dx;
    else ypos+=dy;
    
    tick = -tick;
    
    if (xpos > width-16) dx = -dx;
    if (ypos > height-16) dy = -dy;
    if (xpos < 16) dx = -dx;
    if (ypos < 16) dy = -dy;
  }
}

Dirline dl[] = new Dirline[dlc];

int demo_width = 0;
int demo_height = 0;

public void setup() {
   noCursor();
  demo_width = displayWidth;
  demo_height = displayHeight;
  size(demo_width, demo_height, P3D);
  canvas = createGraphics(demo_width, demo_height, P3D);
  pat = createGraphics(demo_width, demo_height, P3D);
  minim = new Minim(this);
  
  canvas.smooth();
  pat.smooth();

  for (int i=1; i<=18; i++) {
    d_t[i-1] = loadImage(DATAPATH + "alpha_d" + i + ".png");
  }

  s_t[0] = loadImage(DATAPATH + "alpha_text2.png");
  s_t[1] = loadImage(DATAPATH + "alpha_s1.png");
  s_t[2] = loadImage(DATAPATH + "alpha_s2.png");
  s_t[3] = loadImage(DATAPATH + "alpha_s3.png");
  s_t[4] = loadImage(DATAPATH + "alpha_text1.png");
  
  for (int i=0; i < dlc; i++) {
     dl[i] = new Dirline(width/2+cos(i*16)*64,height/2+sin(i*16)*64,cos(i*16*sin(i*32*cos(t()*0.1f+i))*32)*5,sin(i*16)*5);
  }

  canvas.noStroke();
  canvas.noFill();
  noStroke();
  
  blur = loadShader(DATAPATH + "edges.glsl");
  blur.set("resolution", width, height);
  
  blurry = loadShader(DATAPATH + "deform.glsl");
  
  spiikkitunnel = loadShader(DATAPATH + "spiikkitunnel.glsl");

  ilmarieffu = loadShader(DATAPATH + "ilmarieffu.glsl");
  ilmarieffu.set("resolution", PApplet.parseFloat(width), PApplet.parseFloat(height));
  
  visyeffu = loadShader(DATAPATH + "visyeffu.glsl");

  krysler = loadShader(DATAPATH + "krysler.glsl");
  krysler.set("resolution", PApplet.parseFloat(width), PApplet.parseFloat(height));
  
  vis = loadShader(DATAPATH + "vis.glsl");
  vis.set("resolution", PApplet.parseFloat(width), PApplet.parseFloat(height));

  bilologo = loadImage(DATAPATH + "bilotrip.png");
  summon = loadImage(DATAPATH + "alpha_summon.png");
  kredits = loadImage(DATAPATH + "kredits.png");

  song = minim.loadFile(DATAPATH + "song.mp3");
  
  song_end = song.getMetaData().length();
  println(song_end);
  
  
  song.play(WORK_OFFSET);
  
  fft = new FFT(song.bufferSize(), song.sampleRate());
  background(255);
  frameRate(60);
}

public void drawpic(float x, float y, float w,float h, PImage img) {
  canvas.pushMatrix();

  canvas.translate(x, y);
  canvas.beginShape();
  canvas.texture(img);
  canvas.vertex(-w, -h, 0, 0, 0);
  canvas.vertex(w, -h, 0, img.width, 0);
  canvas.vertex(w, h, 0, img.width, img.height);
  canvas.vertex(-w, h, 0, 0, img.height);
  canvas.endShape();

  canvas.popMatrix();
}

float camx=0, camy = 0;

public void draw() {
  
  if (keyPressed) {
    if (key == '1') loopCount = 1;
    if (key == '2') loopCount = 2;
    if (key == '3') loopCount = 3;
    if (key == '4') loopCount = 4;
    if (key == '5') loopCount = 5;
    if (key == '6') loopCount = 6;
    if (key == '7') loopCount = 7;
    if (key == '8') loopCount = 8;
    if (key == '9') loopCount = 9;
  
    boolean skipped = false;
  
    if (key == 'a') { song.play(song.position()-250); skipped = true; }
    if (key == 'd') { song.play(song.position()+250); skipped = true; }
  
    if (key == 'w') { song.play(song.position()-1000); skipped = true; }
    if (key == 's') { song.play(song.position()+1000); skipped = true; }
  
//    if (skipped) song.play();
  
    if (key == 'q') {loopStart = t(); song.setLoopPoints((int)loopStart, (int)loopEnd); }
    if (key == 'e') {loopEnd = t(); song.setLoopPoints((int)loopStart, (int)loopEnd); }
  
    if (key == 'f') recordFract();
  
    if (key == 'p') { pause = -pause; if (pause == 1) song.pause(); else song.play(); } 
    if (key == 'l') { looping = -looping; if (looping == 1) song.loop((int)loopCount); }
    if (key == 'r') song.rewind();
    if (key == 'c') println("sync:" + t());
  
  }
  
  if (song.loopCount() == 0 && looping == 1) { looping = -1; song.pause(); pause = -1; } 


  
  
  fft.forward(song.mix);

  for(int i = 0; i < fft.specSize()/4; i++)
  {
    beat = beat + fft.getBand(i);
  }
  
  beat = beat / fft.specSize()/4;
  
    beat = beat * 0.3f; 
  if (beat < 0) beat = 0;

  // timeline

  if (t() > 0 && t() < 57705) introeffu();
  else if (t() > 57705 && t() < 76733) {
    introeffu();
  } else if (t() > 76733 && t() < 115588) {
    canvas.beginDraw();
  
    cls();

    canvas.translate(width/2,height/2);
    canvas.scale(0.503f+beat*0.05f+0.002f*cos(t()*0.001f+sin(t()*0.002f)));
    drawpic(0, 0, canvas.width, canvas.height, canvas);
    
    if (t() < 96055) canvas.rotateY((cos(t()+0.01f)*0.001f));
    else canvas.rotateX(cos((t()+0.01f)*0.001f));
    canvas.translate(-width/2,-height/2);
    canvas.tint(255,255);
    canvas.noStroke();

    visyeffu.set("time", -t() / 1000.0f);
    canvas.shader(visyeffu);
    canvas.rect(0,0,width,height);

    canvas.endDraw();


    image(canvas,0,0,width,height);
    filter(blurry);  
  } else if (t() > 115588 && t() < 182650) {
    
    canvas.beginDraw();
    cls();
        canvas.tint(252,254+cos(t()*0.001f)*5);
    spiikkitunnel.set("time", (t() / 2000.0f));

        canvas.shader(spiikkitunnel);
        canvas.rect(0,0,width,height);

      canvas.pushMatrix();

    canvas.translate(width/2,height/2);
    tint(255,255);
    canvas.scale(0.50f+beat*0.05f+0.002f*cos(t()*0.001f+sin(t()*0.002f)));
    drawpic(0, 0, canvas.width, canvas.height, canvas);
    
    canvas.rotateZ(cos(t()*0.001f));
    canvas.translate(-width/2,-height/2);

    canvas.popMatrix();
      canvas.pushMatrix();
    updateintrocam();
    canvas.tint(200-cos(t()*0.001f)*30,250-cos(t()*0.002f)*30,250-cos(t()*0.001f)*30,255);



    for (int j = 0; j < 18; j++)
    drawpic(width+(j+12)*(width/4)-(((t()-115588)*(width/16*0.002f))), height/2+height/8*cos(t()*0.001f+j*0.5f), width/16, height/8, d_t[j]);
    //drawpic((j+4*2)*width/4+width/2+width/16, height/2+height/8*cos(t()*0.001+j*0.5), width/16, height/16, d_t[j]);
    canvas.popMatrix();

      if (t() > 173000) drawpic(width/2,height/2, width/2, height, bilologo);

    canvas.endDraw();
  

    image(canvas,0,0,width,height);
    filter(blurry);  

    } else if (t() > 182650 && t() < 192154) {
      
      canvas.beginDraw();
    cls();
        canvas.tint(252,254+cos(t()*0.001f)*5);

      canvas.pushMatrix();

    canvas.translate(width/2,height/2);
    tint(255,255);
    canvas.scale(0.50f+beat*0.05f+0.002f*cos(t()*0.001f+sin(t()*0.002f)));
    drawpic(0, 0, canvas.width, canvas.height, canvas);
    
    canvas.rotateZ(cos(t()*0.001f));
    canvas.translate(-width/2,-height/2);

    canvas.popMatrix();

      drawpic(width/2,height/2, width/2, height, bilologo);

      canvas.endDraw();

      image(canvas,0,0,width,height);
      filter(blurry);  
  } else if (t() > 192154 && t() < 230700) {
      
      canvas.beginDraw();
    cls();
        krysler.set("time", t() / 1000.0f);
        canvas.shader(krysler);
        canvas.rect(0,0,width,height);
        canvas.tint(252,254+cos(t()*0.001f)*5);

      canvas.pushMatrix();

    canvas.translate(width/2,height/2);
    tint(220,252+2*cos(t()*0.001f));
    canvas.scale(0.50f+beat*0.05f+0.002f*cos(t()*0.001f+sin(t()*0.002f)));
    drawpic(0, 0, canvas.width, canvas.height, canvas);
    canvas.noStroke();
    canvas.rotateZ(cos(t()*0.001f));
    canvas.translate(-width/2,-height/2);

    canvas.popMatrix();

      int de_ind = PApplet.parseInt((t() - 192154) / 8000.0f);
  
      float w = width/2;
      float h = height/4;
    
      if (de_ind == 0) {
      w = width/2;
      h = height/16;
      }

      if (de_ind == 3) {
      w = width/3;
      h = height/2;
      }

      if (de_ind == 4) {
      w = width/2;
      h = height/14;
      }
      
      if (de_ind == 4) tint(255,255*cos(t()*0.001f),255*cos(t()*0.001f),255);
      drawpic(width/2,height/2, w, h, s_t[de_ind]);

      canvas.endDraw();

      image(canvas,0,0,width,height);
      filter(blurry);  
  } else if (t() > 230700 && t() < 249850) {
      canvas.beginDraw();
    cls();
        krysler.set("time", t() / 1000.0f);
        canvas.shader(krysler);
        canvas.rect(0,0,width,height);
        canvas.tint(252,254+cos(t()*0.001f)*5);

      canvas.pushMatrix();

    canvas.translate(width/2,height/2);
    tint(220,214+2*cos(t()*0.001f));
    canvas.scale(0.50f+beat*0.05f+0.002f*cos(t()*0.001f+sin(t()*0.002f)));
    drawpic(0, 0, canvas.width, canvas.height, canvas);
    canvas.noStroke();
    canvas.rotateZ(cos(t()+beat*1.1f)*0.01f);
      drawpic(0,0, width, height, summon);

    canvas.translate(-width/2,-height/2);

    canvas.popMatrix();

   

      canvas.endDraw();

      image(canvas,0,0,width,height);
      filter(blurry);  
  } else if (t() > 249850 && t() < 269122.0f) {
      canvas.beginDraw();
      cls();
    
        vis.set("time", t() / 1000.0f);
        canvas.tint(1,10);
        canvas.shader(vis);
        canvas.rect(0,0,width,height);

        canvas.tint(52,1);
        canvas.rect(0,0,width,height);

      canvas.pushMatrix();

    canvas.translate(width/2,height/2);
    tint(220,214+2*cos(t()*0.001f));
    canvas.scale(0.70f+beat*0.05f+0.002f*cos(t()*0.001f+sin(t()*0.002f)));
    drawpic(0, 0, canvas.width, canvas.height, canvas);
    canvas.noStroke();
    canvas.rotateZ(cos(t()*0.001f));
    canvas.translate(-width/2,-height/2);

    canvas.popMatrix();

      
      canvas.endDraw();

      image(canvas,0,0,width,height);
        blur.set("time", t() / 1000.0f);
  blur.set("beat", beat);

            shader(blur);
      filter(blurry);  

  } else if (t() > 269122 && t() < 288230) {
    introeffu();

  } else if (t() > 288230 && t() < song_end-1000) {
      canvas.beginDraw();
    cls();
        canvas.tint(252,254+cos(t()*0.001f)*5);

      canvas.pushMatrix();

    canvas.translate(width/2,height/2);
    tint(255,255);
    canvas.scale(0.50f+beat*0.05f+0.002f*cos(t()*0.001f+sin(t()*0.002f)));
    drawpic(0, 0, canvas.width, canvas.height, canvas);
    
    canvas.rotateZ(cos(t()*0.001f));
    canvas.translate(-width/2,-height/2);

    canvas.popMatrix();

      if (t() < song_end - 2000) drawpic(width/2,height/2, width/4, height/2, kredits);

      canvas.endDraw();

      image(canvas,0,0,width,height);
      filter(blurry);  
  }
  
  if (t() >= song_end-400) stop();

}

public void cls() {
  canvas.background(255-t()*0.0001f,1);
}

public void updateintrocam() {
  //camx = -t()*0.19;
  //canvas.translate(camx, camy);
}


public void introeffu() {
  //canvas.resetShader();    
  //resetShader();
 
  canvas.beginDraw();
  

  cls();

  canvas.pushMatrix();
  canvas.translate(width/2,height/2);
  canvas.scale(0.40f+t()*(0.0002f-(t()*0.00000000005f)));
  canvas.pushMatrix();
  canvas.rotateZ(cos(t()*0.00007f)*1);
  canvas.rotateX(cos(t()*0.00007f)*1);
  canvas.tint(cos(t())*244,t()*0.0007f);
  drawpic(0, 0, canvas.width, canvas.height, canvas);
  if (t() < 57950) canvas.rotateZ(sin(t()*0.00007f)*1);
  else canvas.rotateY(sin(t()*0.0007f)*0.5f);
  drawpic(0, 0, canvas.width, canvas.height, canvas);
  canvas.popMatrix();

  canvas.translate(-width/2,-height/2);
  canvas.tint(255,255);
  canvas.noStroke();
  canvas.popMatrix();
  
  canvas.pushMatrix();
  pat.stroke(0);
  for (int i = 0; i < dlc; i++) {
  dl[i].draw(i);
  }
  canvas.popMatrix();
  spiikkitunnel.set("time", t() / 1000.0f);

  canvas.shader(spiikkitunnel);
  canvas.rect(0, 0, width, height);  
  
  canvas.endDraw();

  blur.set("time", t() / 1000.0f);
  blur.set("beat", beat);

  shader(blurry);


  image(pat, 0, 0, width, height);
  //shader(blur);
  if (t() < 38480) {
  if (tick == 1) shader(blur);
  tick = -tick;
  }
  image(canvas, 0, 0, width, height);
  filter(blurry);  
 
}

public void recordFract() {
  float lc = loopCount;
  
}

public void keyPressed() {
  if (keyCode == ESC) stop();
}









public void stop() {
  song.pause();
  
  song.close();
  minim.stop();
  super.stop();
  
  exit();
}






  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "sundown_demo" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
