#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

uniform float beat;

uniform sampler2D textureSampler;
uniform vec2 texcoordOffset;

varying vec4 vertColor;
varying vec4 vertTexcoord;

uniform vec2 resolution;
uniform float time;

#define KERNEL_SIZE 9

// Edge detection kernel
// -1 -1 -1
// -1 +8 -1
// -1 -1 -1
float kernel[KERNEL_SIZE];

vec2 offset[KERNEL_SIZE];

void main(void) {
    int zz = 0;
    vec4 sum = vec4(0.0);

    offset[0] = vec2(-texcoordOffset.s, -texcoordOffset.t);
    offset[1] = vec2(0.0, -texcoordOffset.t);
    offset[2] = vec2(texcoordOffset.s, -texcoordOffset.t);

    offset[3] = vec2(-texcoordOffset.s, 0.0);
    offset[4] = vec2(0.0, 0.0);
    offset[5] = vec2(texcoordOffset.s, 0.0);

    offset[6] = vec2(-texcoordOffset.s, texcoordOffset.t);
    offset[7] = vec2(0.0, texcoordOffset.t);
    offset[8] = vec2(texcoordOffset.s, texcoordOffset.t);

    kernel[0] = -1.0;   kernel[1] = 2.0;   kernel[2] = 1.0;
    kernel[3] = -2.0;   kernel[4] = 2.2;    kernel[5] = -2.0;
    kernel[6] = 1.0;   kernel[7] = -1.0;   kernel[8] = -1.0;

    for(zz = 0; zz < KERNEL_SIZE; zz++) {
        vec4 tmp = texture2D(textureSampler, vertTexcoord.st + offset[zz]);
        sum += tmp * kernel[zz];
    }

    vec4 r1 = vec4(sum.rgb, 1.0) * vertColor;


	float t = cos(time*0.1*beat)* sin(beat*time*0.01);

    vec2 p = -1.0 + 2.0 * gl_FragCoord.xy / resolution.xy;
    float a = (time*40.0)*10.0*beat;
    float d,e,f,g=1.0/40.0,h,i,r,q;
    e=400.0*(p.x*0.5+0.5);
    f=400.0*(p.y*0.5+0.5);
    i=200.0+sin(e*g+a/150.0)*20.0;
    d=200.0+cos(f*g/2.0)*18.0+atan(e*g)*7.0;
    r=sqrt(pow(i-e,2.0)+pow(d-f,2.0));
    q=f/r;
    e=(r*sin(q*0.8))-a/2.0;f=(r*sin(q+t))-a/2.0;
    d=atan(e*g)*176.0+tan(e*g)*164.0+r;
    h=((f+d)+a/2.0)*g;
    i=cos(h+r*p.x/1.3)*(e+e+a)+cos(q*g*6.0)*(r+h/3.0);
    h=sin(f*g)*144.0-sin(e*g)*212.0*p.x;
    h=(h+(f-e)*q+sin(r-(a+h)/7.0)*10.0+i/4.0)*g;
    i+=cos(h*2.3*sin(a/350.0-q))*184.0*sin(q-(r*4.3+a/12.0)*g)+atan(r*g+h)*184.0*sin(r*g+h);
    i=mod(i/3.6,256.0)/64.0;
    if(i<0.0) i+=2.0;
    if(i>=2.0) i=1.0-i;
    d=r/150.0;
    d+=sin(d*d*8.0)*0.52;
    f=(sin(a*g)+1.0)/2.0;
		gl_FragColor=vec4(vec3(r1.r/f*i/5.6,r1.g-i/2.0+d/13.0,r1.b-i)*d*p.x+vec3(r1.g*i/1.3+d/8.0,r1.b-i/2.0+d/18.0,r1.r-i)*d-r1.r*(0.6-p.x),0.7/(0.1+t*0.0001)*t);
}
