


uniform float time;

void hullu(inout vec3 z, float zr0, inout float dr)
{


  float P=3.+10.+10.*cos(3.14+.1*time);
  float zo0 = asin( z.z/zr0 );
  float zi0 = atan( z.y,z.x );

  float zr = pow( zr0, P-1. );
  float zo = zo0 * P;
  float zi = zi0 * P;
  
  dr = zr*dr*P + 1.;
  zr *= zr0;
  z  = zr*vec3( cos(zo)*cos(zi), cos(zo)*sin(zi), sin(zo) );


  
}


void rX(inout vec3 p, float a) 
	{
        float c,s;
		vec3 q=p;
        c = cos(a); s = sin(a);
        p.y = c * q.y - s * q.z;
        p.z = s * q.y + c * q.z;
        //return vec3(p);
	}

void rY(inout vec3 p, float a)
	{
        float c,s;
		vec3 q=p;
        c = cos(a); s = sin(a);
        p.x = c * q.x + s * q.z;
        p.z = -s * q.x + c * q.z;
	}

void rZ(inout vec3 p, float a) 
	{
        float c,s;
		vec3 q=p;
        c = cos(a); s = sin(a);
        p.x = c * q.x - s * q.y;
        p.y = s * q.x + c * q.y;
	}


float perlin(vec3 p)
	{
        vec3 i = floor(p);
        vec4 a = dot(i, vec3(1., 57., 21.)) + vec4(0., 57., 21., 78.);
        vec3 f = cos((p-i)*acos(-1.))*(-.5)+.5;
        a = mix(sin(cos(a)*a),sin(cos(1.+a)*(1.+a)), f.x);
        a.xy = mix(a.xz, a.yw, f.y);
        return mix(a.x, a.y, f.z);
	}





float mandelbulb(vec3 o)
	{

  vec3 z=o;
  float r;
  float dr=1.;
  r=length(z);
  for (float i=6.;i>0.;i--){
		
    hullu(z,r,dr);
	
	z+=o;
    r=length(z);
	if (r<16.) break;

	}
	return -0.5*log(r)*(r/dr);


  
}



float f(vec3 o)
	{
	float oy = o.y;
	o = o*1.;

  float t=.1*time;

       float pi = 3.14159265;


   float size=-.2*-pi;

	float m=1.;


	o.z-= 1.5;//-time*.05;

       rY(o,pi/2.);

	   rZ(o,pi/4.);
       rX(o,pi/2.);



	size = -3.9;
	//size+=.04*(sin(16.*o.x+time)+cos(16.*o.y+time)+cos(16.*o.z-time) );

   float R = length(o);
   float omega = acos((o.z+.1*sin(time)) / R);
   float fii = atan(o.y , o.x);
   vec3 men = vec3(R,omega,fii);


	if (length(o)>.5) m=mandelbulb(.3*men);
	



	size = -4.8;
   if (m>0.)
  {
	return length(1.*o);  //pallo
	}
	else return 7.;

	}


vec3 normal(vec3 p)
	{
	vec3 e = vec3(.1, 0.0, 0.0);
	vec3 n;
	n.x = f(p + e.xyy) - f(p - e.xyy);
	n.y = f(p + e.yxy) - f(p - e.yxy);
	n.z = f(p + e.yyx) - f(p - e.yyx);
	return normalize(n);
}



vec3 rm(inout vec3 p, inout vec3 d, float s, float t, int n)	
		{
       rY(p,.6);
       rZ(p,.3);
	   
       vec3 q=p;
 
        float l;
        float x=0.;
		
	
		for (int i=50;i<100;i+=1)
			{
                vec3 rot;
				
                l=abs(f(p));
				p+=l*d*s;
                x+=.07;
                if (l<.5) break;
        }
     

      vec3 e=vec3(0.0,0.0,0.0);
      vec3 sp=q; //+d*t;
      vec3 nn=-normalize(vec3(f(sp+e),f(sp+e.yxy),f(sp+e.yyx))+vec3((sin(sp*75.)))*.01);


return .1*vec3(x)+vec3(1.9-1.8*length(q-p),1.9-1.9*length(q-p),1.9+.05*x-1.9*length(q-p));

}


uniform vec2 resolution;
void main( void ) {

	 vec2 p = -1.0 + 2.0 * vec2(gl_FragCoord.x,gl_FragCoord.y) / vec2(640.0,560.0);
 vec3 o=.05*vec3(p.x,p.y,-1.0);
	vec3 d=1.*vec3(p.x,p.y,.7)/(.5*512.);

   vec4 ray = vec4(rm(o,d,1.1,.5,25)/8.  ,1.0);
  
  
    vec4 vari = vec4(vec3(.1),.01)- 3.* ray;

 gl_FragColor = vec4(vari.xyz,1.0);
		

}
